
import java.awt.*;
import java.awt.image.*;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;



public class ImageToArray {
	

	public static void main(String args[])
	{
		JFileChooser fc = new JFileChooser();
		
		int returnVal = fc.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) 
        {
            File file = fc.getSelectedFile();
            try {
            	BufferedImage image = ImageIO.read(file);
				final byte[] pixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
			    final int width = image.getWidth();
			    final int height = image.getHeight();
			    final boolean hasAlphaChannel = image.getAlphaRaster() != null;

			    int[][] result = new int[width][height];
			    if (hasAlphaChannel) 
			    {
			    	final int pixelLength = 4;
			        for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) 
			        {
			        	int argb = 0;
			            argb += (((int) pixels[pixel] & 0xff) << 24); // alpha
			            argb += ((int) pixels[pixel + 1] & 0xff); // blue
			            argb += (((int) pixels[pixel + 2] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 3] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) 
			            {
			            	col = 0;
			            	row++;
			            }
			        }
			     } else {
			         final int pixelLength = 3;
			         for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) {
			            int argb = 0;
			            argb += -16777216; // 255 alpha
			            argb += ((int) pixels[pixel] & 0xff); // blue
			            argb += (((int) pixels[pixel + 1] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 2] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) {
			               col = 0;
			               row++;
			            }
			         }
			      }
			    
			    
			    ArrayList<Color> listaColores=new ArrayList<Color>();
			    
			    
			    //buscar los 4 colores
			    int xx=0;
			    int yy=0;
			    while(listaColores.size()<4)
			    {
			    	Color col=new Color(result[xx][yy]);
			    	if(listaColores.indexOf(col)<0)
			    	{
			    		listaColores.add(col);
			    	}
			    	yy=yy+1;
			    	if(yy==height)
			    	{
			    		yy=0;
			    		xx=xx+1;
			    	}
			    }
			    
			    
			    //ordenar los 4 colores de más claros a más oscuros
			   
		    	listaColores.sort(new Comparator(){

					@Override
					public int compare(Object o1, Object o2) {
						Color c1=(Color)o1;
						Color c2=(Color)o2;
						return (c2.getRed()+c2.getBlue()+c2.getGreen())-(c1.getRed()+c1.getBlue()+c1.getGreen());
					}
		    		
		    	});
			   
		    	Color colBlack=listaColores.get(3);
		    	listaColores.remove(3);
		    	listaColores.add(0, colBlack);
			    
			    //mover los colores para que el más oscuro quede el primero y el resto igual
			    
		    	String viajaso="";
			    /*
			     	#define PIX_0_PAL_0 0b00000000	0
					#define PIX_0_PAL_1 0b10000000	128
					#define PIX_0_PAL_2 0b00001000	8
					#define PIX_0_PAL_3 0b10001000	136
					
					#define PIX_1_PAL_0 0b00000000	0
					#define PIX_1_PAL_1 0b01000000	64
					#define PIX_1_PAL_2 0b00000100	4
					#define PIX_1_PAL_3 0b01000100	68
					
					#define PIX_2_PAL_0 0b00000000	0
					#define PIX_2_PAL_1 0b00100000	32
					#define PIX_2_PAL_2 0b00000010	2
					#define PIX_2_PAL_3 0b00100010	34
					 
					#define PIX_3_PAL_0 0b00000000	0
					#define PIX_3_PAL_1 0b00010000	16
					#define PIX_3_PAL_2 0b00000001	1
					#define PIX_3_PAL_3 0b00010001 	17
			     */
		    	int counter=0;
		    	int counterTotal=0;
		    	int desp=0;
		    	int acumTrama=0;
		    	int lastNumber=-1;
		    	xx=0;
			    yy=0;
			    while(xx<width)
			    {
			    	Color colA=listaColores.get(0);
			    	Color colB=listaColores.get(0);
			    	Color colC=listaColores.get(0);
			    	Color colD=listaColores.get(0);
			    	if(xx>2)
			    	{
			    		colA=new Color(result[xx-4][yy]);
			    		colB=new Color(result[xx-3][yy]);
			    		colC=new Color(result[xx-2][yy]);
			    		colD=new Color(result[xx-1][yy]);
			    	}
			    	Color col1=new Color(result[xx][yy]);
			    	Color col2=new Color(result[xx+1][yy]);
			    	Color col3=new Color(result[xx+2][yy]);
			    	Color col4=new Color(result[xx+3][yy]);
			    	
			    	if(col1.equals(colA)==false || col2.equals(colB)==false || col3.equals(colC)==false || col4.equals(colD)==false)
			    	{
			    		if(desp>0)
			    		{
			    			if(acumTrama>0)
			    			{
			    				viajaso=viajaso+","+(acumTrama+230);
					    		counterTotal=counterTotal+1;
					    		counter=counter+1;
					    		acumTrama=0;
					    		lastNumber=-1;
			    			}
			    			
			    			
			    			viajaso=viajaso+","+(desp+200);
			    			counterTotal=counterTotal+1;
			    			desp=0;
			    			acumTrama=0;
			    			lastNumber=-1; 
			    		}
			    		
			    		int number=calcByteValue(listaColores,new Color(result[xx][yy]),new Color(result[xx+1][yy]), new Color(result[xx+2][yy]), new Color(result[xx+3][yy]));
			    		if(lastNumber==number && acumTrama<20)
			    		{
			    			acumTrama=acumTrama+1;
			    		}else{
			    			if(acumTrama>0)
			    			{
			    				viajaso=viajaso+","+(acumTrama+230);
					    		counterTotal=counterTotal+1;
					    		counter=counter+1;
					    		acumTrama=0;
			    			}
		    				viajaso=viajaso+","+yy+","+number;
				    		counterTotal=counterTotal+2;
				    		counter=counter+1;
				    		lastNumber=number;
			    		}
			    		if(counter>50)
			    		{
			    			counter=0;
			    			viajaso=viajaso+"\n";
			    		}
			    	}else{
			    		lastNumber=-1;
			    	}
			    	
			    	
			    	
			    	
			    	
			    	yy=yy+1;
			    	if(yy==height)
			    	{
			    		yy=0;
			    		xx=xx+4;
			    		desp=desp+1;
			    		if(desp==30)
			    		{
			    			if(acumTrama>0)
			    			{
			    				viajaso=viajaso+","+(acumTrama+230);
					    		counterTotal=counterTotal+1;
					    		counter=counter+1;
					    		acumTrama=0;
					    		lastNumber=-1;
			    			}
			    			
			    			viajaso=viajaso+","+(desp+200);
			    			counterTotal=counterTotal+1;
			    			desp=0;
			    		}
			    	}
			    }
			    
			    if(acumTrama>0)
    			{
    				viajaso=viajaso+","+(acumTrama+230);
		    		counterTotal=counterTotal+1;
		    		counter=counter+1;
		    		acumTrama=0;
		    		lastNumber=-1;
    			}
			    
			    viajaso=viajaso+",200";
			    counterTotal=counterTotal+1;
			    System.out.println("OOOOMA: "+viajaso.substring(1) );
			    System.out.println("TOTAL: "+counterTotal);
			    
			    PrintWriter writer = new PrintWriter(file.getAbsolutePath().replaceAll("\\.png", ".level"), "UTF-8");
			    writer.println("extern const u8 "+file.getName().replaceAll("\\.png", "")+"["+counterTotal+"];");
			    
			    writer.println("const u8 "+file.getName().replaceAll("\\.png", "")+"["+counterTotal+"]={");
			    writer.println(viajaso.substring(1));
			    writer.println("};");
			    
			    writer.close();
			    
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

        }
	}
	
	static int calcByteValue(ArrayList<Color> listaColores,Color col1,Color col2, Color col3, Color col4)
	{
		int number=0;
    	int ind1=listaColores.indexOf(col1);
    	int ind2=listaColores.indexOf(col2);
    	int ind3=listaColores.indexOf(col3);
    	int ind4=listaColores.indexOf(col4);
    	if(ind1==1){
    		number=number+128;
    	}else if(ind1==2){
    		number=number+8;
    	}else if(ind1==3){
    		number=number+136;
    	}
    	
    	if(ind2==1){
    		number=number+64;
    	}else if(ind2==2){
    		number=number+4;
    	}else if(ind2==3){
    		number=number+68;
    	}
    	
    	if(ind3==1){
    		number=number+32;
    	}else if(ind3==2){
    		number=number+2;
    	}else if(ind3==3){
    		number=number+34;
    	}
    	
    	if(ind4==1){
    		number=number+16;
    	}else if(ind4==2){
    		number=number+1;
    	}else if(ind4==3){
    		number=number+17;
    	}
    	return number;
	}
}
