import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;



public class ImageToTiles {
	public static void main(String args[])
	{
		JFileChooser fc = new JFileChooser();
		
		int returnVal = fc.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) 
        {
            File file = fc.getSelectedFile();
            try {
            	BufferedImage image = ImageIO.read(file);
				final byte[] pixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
			    final int width = image.getWidth();
			    final int height = image.getHeight();
			    final boolean hasAlphaChannel = image.getAlphaRaster() != null;

			    int[][] result = new int[width][height];
			    if (hasAlphaChannel) 
			    {
			    	final int pixelLength = 4;
			        for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) 
			        {
			        	int argb = 0;
			            argb += (((int) pixels[pixel] & 0xff) << 24); // alpha
			            argb += ((int) pixels[pixel + 1] & 0xff); // blue
			            argb += (((int) pixels[pixel + 2] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 3] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) 
			            {
			            	col = 0;
			            	row++;
			            }
			        }
			     } else {
			         final int pixelLength = 3;
			         for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) {
			            int argb = 0;
			            argb += -16777216; // 255 alpha
			            argb += ((int) pixels[pixel] & 0xff); // blue
			            argb += (((int) pixels[pixel + 1] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 2] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) {
			               col = 0;
			               row++;
			            }
			         }
			      }
			    
			    
			    ArrayList<Color> listaColores=new ArrayList<Color>();
			    
			    
			    //buscar los 4 colores
			    int xx=0;
			    int yy=0;
			    while(listaColores.size()<4)
			    {
			    	Color col=new Color(result[xx][yy]);
			    	if(listaColores.indexOf(col)<0)
			    	{
			    		listaColores.add(col);
			    	}
			    	yy=yy+1;
			    	if(yy==height)
			    	{
			    		yy=0;
			    		xx=xx+1;
			    	}
			    }
			    
			    
			    //ordenar los 4 colores de más claros a más oscuros
			   
		    	listaColores.sort(new Comparator(){

					@Override
					public int compare(Object o1, Object o2) {
						Color c1=(Color)o1;
						Color c2=(Color)o2;
						return (c2.getRed()+c2.getBlue()+c2.getGreen())-(c1.getRed()+c1.getBlue()+c1.getGreen());
					}
		    		
		    	});
			   
		    	Color colBlack=listaColores.get(3);
		    	listaColores.remove(3);
		    	listaColores.add(0, colBlack);
			    
		    	
		    	
		    	//defino la listaka de tiles  lista de listas de 32 colores 8 filas por 4 columnas
		    	ArrayList<ArrayList<Color>> listaTiles=new ArrayList<ArrayList<Color>>();
		    	ArrayList<Color> tileZero=new ArrayList<Color>();
		    	for(int auxc=0; auxc<32; auxc++)
		    	{
		    		tileZero.add(listaColores.get(0));
		    	}
		    	listaTiles.add(tileZero); //agregamos el primer tile a la lista que es el tile zero que tiene todo a zero
		    	
		    	
		    	
			    //mover los colores para que el más oscuro quede el primero y el resto igual
			    
		    	String viajaso="";
			    /*
			     	#define PIX_0_PAL_0 0b00000000	0
					#define PIX_0_PAL_1 0b10000000	128
					#define PIX_0_PAL_2 0b00001000	8
					#define PIX_0_PAL_3 0b10001000	136
					
					#define PIX_1_PAL_0 0b00000000	0
					#define PIX_1_PAL_1 0b01000000	64
					#define PIX_1_PAL_2 0b00000100	4
					#define PIX_1_PAL_3 0b01000100	68
					
					#define PIX_2_PAL_0 0b00000000	0
					#define PIX_2_PAL_1 0b00100000	32
					#define PIX_2_PAL_2 0b00000010	2
					#define PIX_2_PAL_3 0b00100010	34
					 
					#define PIX_3_PAL_0 0b00000000	0
					#define PIX_3_PAL_1 0b00010000	16
					#define PIX_3_PAL_2 0b00000001	1
					#define PIX_3_PAL_3 0b00010001 	17
			     */
		    	//int counter=0;
		    	int counterTotal=0;
		    	int desp=0;
		    	//int acumTrama=0;
		    	//int lastNumber=-1;
		    	xx=0;
			    yy=0;
			    while(xx<width)
			    {
			    	
			    	int tileSelect=checkAndAddTile(listaTiles,result,xx,yy);
			    	if(tileSelect>-1)
			    	{
			    		if(desp>0)
			    		{
			    			viajaso=viajaso+"\n,"+(desp+200);
			    			counterTotal=counterTotal+1;
			    			desp=0;
			    		}
			    		viajaso=viajaso+","+yy+","+tileSelect;
			    		counterTotal=counterTotal+2;
			    	}
			    	
			    	yy=yy+8;
			    	if(yy>=height)
			    	{
			    		yy=0;
			    		xx=xx+4;
			    		desp=desp+1;
			    		if(desp==30)
			    		{
			    			viajaso=viajaso+"\n,"+(desp+200);
			    			counterTotal=counterTotal+1;
			    			desp=0;
			    		}
			    	}
			    }
			    
			    viajaso=viajaso+",200";
			    counterTotal=counterTotal+1;
			    
			    //ahora agregamos la lista de tiles al principio
			    String viajasoTiles=""+listaTiles.size(); //agregamos el numero de tiles que se van a usar
			    counterTotal=counterTotal+1;
			    //y agregamos la lista de tiles
			    for(int auxlc=0; auxlc<listaTiles.size(); auxlc++)
			    {
			    	viajasoTiles=viajasoTiles+"\n";
			    	ArrayList<Color> tileSel=listaTiles.get(auxlc);
			    	for(int auxti=0;auxti<32; auxti=auxti+4)
			    	{
			    		int ic1=calcByteValue(listaColores,tileSel.get(auxti),tileSel.get(auxti+1),tileSel.get(auxti+2),tileSel.get(auxti+3));
			    		viajasoTiles=viajasoTiles+","+ic1;
			    		counterTotal=counterTotal+1;
			    	}
			    }
			    //agregamos todo
			    viajaso=viajasoTiles+"\n\n"+viajaso;
			    
			    
			    System.out.println("OOOOMA: "+viajaso );
			    System.out.println("TOTAL: "+counterTotal);
			    
			    PrintWriter writer = new PrintWriter(file.getAbsolutePath().replaceAll("\\.png", ".tiles"), "UTF-8");
			    writer.println("extern const u8 "+file.getName().replaceAll("\\.png", "")+"["+counterTotal+"];");
			    
			    writer.println("const u8 "+file.getName().replaceAll("\\.png", "")+"["+counterTotal+"]={");
			    writer.println(viajaso);
			    writer.println("};");
			    
			    writer.close();
			    
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

        }
	}
	
	private static int checkAndAddTile(ArrayList<ArrayList<Color>> listaTiles, int[][] result, int xx, int yy) {
		//saca los 32 colores del tile actual y del anterior (si es posible)
		ArrayList<Color> tileActual=new ArrayList<Color>();
		ArrayList<Color> tileAnterior=new ArrayList<Color>();
		
		for(int auxfila=0; auxfila<8; auxfila++)
		{
			tileActual.add(new Color(result[xx][yy+auxfila]));
			tileActual.add(new Color(result[xx+1][yy+auxfila]));
			tileActual.add(new Color(result[xx+2][yy+auxfila]));
			tileActual.add(new Color(result[xx+3][yy+auxfila]));
			
			if(xx>2)
			{
				tileAnterior.add(new Color(result[xx-4][yy+auxfila]));
				tileAnterior.add(new Color(result[xx-3][yy+auxfila]));
				tileAnterior.add(new Color(result[xx-2][yy+auxfila]));
				tileAnterior.add(new Color(result[xx-1][yy+auxfila]));
			}else{
				tileAnterior=listaTiles.get(0);
			}
		}
		
		//comprueba si existe en la lista de tiles
		int encontrado=-1;
		for(int auxlt=0; auxlt<listaTiles.size(); auxlt++)
		{
			ArrayList<Color> tileBusca=listaTiles.get(auxlt);
			boolean dif=false;
			for(int auxtb=0; auxtb<32; auxtb++)
			{
				if(tileBusca.get(auxtb).equals(tileActual.get(auxtb))==false)
				{
					dif=true;
					break;
				}
			}
			if(dif==false)
			{
				//este es el tile que estabamos buscando
				encontrado=auxlt;
				break;
				//sino sigo buscando hasta el final
			}
		}
		
		//si no existe lo agrega a la lista de tiles
		if(encontrado<0)
		{
			listaTiles.add(tileActual);
			return listaTiles.size()-1; //devuelvo que es el ultimo tile el que estaba buscando ademas al ser nuevo es diferente al tile anterior seguro
		}
		
		//comprueba si el tile actual y el anterior son iguales o no
		boolean dif=false;
		for(int auxtb=0; auxtb<32; auxtb++)
		{
			if(tileAnterior.get(auxtb).equals(tileActual.get(auxtb))==false)
			{
				dif=true;
				break;
			}
		}
		
		//en caso de ser iguales se devuelve un -1 para que no haga nada
		if(dif==false)
		{
			return -1;
		}else{
		//	en caso de ser diferentes se devuelve el indice de ese tile para que se agregue a la lista
			return encontrado;
		}
	}

	static int calcByteValue(ArrayList<Color> listaColores,Color col1,Color col2, Color col3, Color col4)
	{
		int number=0;
    	int ind1=listaColores.indexOf(col1);
    	int ind2=listaColores.indexOf(col2);
    	int ind3=listaColores.indexOf(col3);
    	int ind4=listaColores.indexOf(col4);
    	if(ind1==1){
    		number=number+128;
    	}else if(ind1==2){
    		number=number+8;
    	}else if(ind1==3){
    		number=number+136;
    	}
    	
    	if(ind2==1){
    		number=number+64;
    	}else if(ind2==2){
    		number=number+4;
    	}else if(ind2==3){
    		number=number+68;
    	}
    	
    	if(ind3==1){
    		number=number+32;
    	}else if(ind3==2){
    		number=number+2;
    	}else if(ind3==3){
    		number=number+34;
    	}
    	
    	if(ind4==1){
    		number=number+16;
    	}else if(ind4==2){
    		number=number+1;
    	}else if(ind4==3){
    		number=number+17;
    	}
    	return number;
	}
}
