import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class TmxToSceneOpt {
	public static void main(String args[])
	{
		class Objetin {
			String n;
			int y;
			int x;
			String t;
			@Override
			public String toString() {
				
				return ""+x+","+n+","+y+",";
			}
			
			
		}
		
		JFileChooser fc = new JFileChooser();
	
		FileNameExtensionFilter filter = new FileNameExtensionFilter("TMX FILES", "tmx", "tmx");
		fc.setFileFilter(filter);
		
		int returnVal = fc.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) 
        {
            File file = fc.getSelectedFile();
            try {
            	DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
            	DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
            	Document document = documentBuilder.parse(file);
            	Node nodeObjectGroup=document.getElementsByTagName("objectgroup").item(0);
            	ArrayList<Objetin> listaObj=new ArrayList<Objetin>();
            	NodeList listaObjects=nodeObjectGroup.getChildNodes();
            	for(int i=0; i<listaObjects.getLength(); i++)
            	{
            		Node n=listaObjects.item(i);
            		if(n!=null && n.getAttributes()!=null && n.getAttributes().getNamedItem("name")!=null)
            		{
            			String name=n.getAttributes().getNamedItem("name").getTextContent();
            			String x=n.getAttributes().getNamedItem("x").getTextContent();
            			String y=n.getAttributes().getNamedItem("y").getTextContent();
            			String t=null;
            			if(n.getAttributes().getNamedItem("type")!=null)
            				t=n.getAttributes().getNamedItem("type").getTextContent();
            			
            			Objetin objetin=new Objetin();
            			objetin.n=name;
            			objetin.x=(int)Math.floor(Double.parseDouble(x)/4.0);
            			objetin.y=((int)(Double.parseDouble(y)/8.0)) *8;
            			objetin.t=t;
						listaObj.add(objetin);
            			
            		}
            	}
            	
            	Collections.sort(listaObj,new Comparator<Objetin>() {
                    public int compare(Objetin o1, Objetin o2) {
                    	return o1.x-o2.x;
                    }
            	});
            	
            	System.out.println(listaObj.toString());
            	
            	
            	String finalOpt="";
            	int counter=0;
            	int desp=0;
            	String lastN="";
            	Iterator<Objetin> it=listaObj.iterator();
            	while(it.hasNext())
            	{
            		Objetin obj=it.next();

            		//si han pasado más de 250 debe meter un 250,0 para que no haga nada
            		//si ha finalizado el nivel debe meter un x,255
            		System.out.println("\nX="+obj.x);
            		System.out.println("\nDesp="+desp);
            		int despNuevo=obj.x-desp;
            		desp=obj.x;
            		while(despNuevo>252)
            		{
            			//metemos un separador de 250 con 0 
            			finalOpt=finalOpt+"\n252,0,\n";
	            		counter=counter+2;
	            		despNuevo=despNuevo-252;
	            		lastN="";
            		}
            		
            		
            		if(obj.n.equals(lastN)==false)
        			{
        				finalOpt=finalOpt+"\n";
        			}
        			lastN=obj.n;
            		finalOpt=finalOpt+""+despNuevo+","+obj.n+",";
            		counter=counter+2;
            		if(obj.n.equals("0") || obj.n.equals("255"))
            		{
            			//aqui no metemos la altura porke no hace falta
            		}else{
            			if(obj.t!=null && obj.t.equals("")==false)
            			{
            				finalOpt=finalOpt+obj.t+",";
            			}else{
            				finalOpt=finalOpt+obj.y+",";
            			}
            			counter=counter+1;
            		}
            		finalOpt=finalOpt+"\n";
            	}
            	
            	
            	
            	/*
            	EJEMPLO...
            	
            	const u8 scene1opt[67]={
				//naves principales
				20,100,50,
				20,100,60,
				10,100,70,
				10,100,80,
				10,100,70,
				6,100,60,
				6,100,80,
				6,100,100,
				4,100,110,
				3,100,50,
				
				//primera torreta
				1,111,152,
				
				//mas naves
				30,100,50,
				10,100,60,
				8,100,80,
				8,100,70,
				8,100,50,
				
				//chorrazo de torretas
				10,111,152,
				20,111,152,
				40,111,152,
				5,111,152,
				10,111,152,
				
				//fin escenario
				250,0,
				250,255
				
				};

            	 * */

            	finalOpt=finalOpt.substring(0,finalOpt.length()-2);
            	
            	
            	PrintWriter writer = new PrintWriter(file.getAbsolutePath().replaceAll("\\.tmx", ".opt"), "UTF-8");
			    writer.println("extern const u8 "+file.getName().replaceAll("\\.tmx", "opt")+"["+counter+"];");
			    
			    writer.println("const u8 "+file.getName().replaceAll("\\.tmx", "opt")+"["+counter+"]={");
			    writer.println(finalOpt);
			    writer.println("};");
			    
			    writer.close();
            	
            	//String usr = document.getElementsByTagName("user").item(0).getTextContent();
            	//String pwd = document.getElementsByTagName("password").item(0).getTextContent();
            	
            	
            	/*BufferedImage image = ImageIO.read(file);
				final byte[] pixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
			    final int width = image.getWidth();
			    final int height = image.getHeight();
			    final boolean hasAlphaChannel = image.getAlphaRaster() != null;

			    int[][] result = new int[width][height];
			    if (hasAlphaChannel) 
			    {
			    	final int pixelLength = 4;
			        for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) 
			        {
			        	int argb = 0;
			            argb += (((int) pixels[pixel] & 0xff) << 24); // alpha
			            argb += ((int) pixels[pixel + 1] & 0xff); // blue
			            argb += (((int) pixels[pixel + 2] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 3] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) 
			            {
			            	col = 0;
			            	row++;
			            }
			        }
			     } else {
			         final int pixelLength = 3;
			         for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) {
			            int argb = 0;
			            argb += -16777216; // 255 alpha
			            argb += ((int) pixels[pixel] & 0xff); // blue
			            argb += (((int) pixels[pixel + 1] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 2] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) {
			               col = 0;
			               row++;
			            }
			         }
			      }
			    
			    
			    ArrayList<Color> listaColores=new ArrayList<Color>();
			    
			    
			    //buscar los 4 colores
			    int xx=0;
			    int yy=0;
			    while(listaColores.size()<4)
			    {
			    	Color col=new Color(result[xx][yy]);
			    	if(listaColores.indexOf(col)<0)
			    	{
			    		listaColores.add(col);
			    	}
			    	yy=yy+1;
			    	if(yy==height)
			    	{
			    		yy=0;
			    		xx=xx+1;
			    	}
			    }
			    
			    
			    //ordenar los 4 colores de mÃ¡s claros a mÃ¡s oscuros
			   
		    	listaColores.sort(new Comparator(){

					@Override
					public int compare(Object o1, Object o2) {
						Color c1=(Color)o1;
						Color c2=(Color)o2;
						return (c2.getRed()+c2.getBlue()+c2.getGreen())-(c1.getRed()+c1.getBlue()+c1.getGreen());
					}
		    		
		    	});
			   
		    	Color colBlack=listaColores.get(3);
		    	listaColores.remove(3);
		    	listaColores.add(0, colBlack);
			    
		    	
		    	
		    	//defino la listaka de tiles  lista de listas de 32 colores 8 filas por 4 columnas
		    	ArrayList<ArrayList<Color>> listaTiles=new ArrayList<ArrayList<Color>>();
		    	ArrayList<Color> tileZero=new ArrayList<Color>();
		    	for(int auxc=0; auxc<32; auxc++)
		    	{
		    		tileZero.add(listaColores.get(0));
		    	}
		    	listaTiles.add(tileZero); //agregamos el primer tile a la lista que es el tile zero que tiene todo a zero
		    	
		    	
		    	
			    //mover los colores para que el mÃ¡s oscuro quede el primero y el resto igual
			    
		    	String viajaso="";
			    
		    	//int counter=0;
		    	int counterTotal=0;
		    	int desp=0;
		    	//int acumTrama=0;
		    	//int lastNumber=-1;
		    	xx=0;
			    yy=0;
			    while(xx<width)
			    {
			    	
			    	int tileSelect=checkAndAddTile(listaTiles,result,xx,yy);
			    	if(tileSelect>-1)
			    	{
			    		if(desp>0)
			    		{
			    			viajaso=viajaso+"\n,"+(desp+200);
			    			counterTotal=counterTotal+1;
			    			desp=0;
			    		}
			    		viajaso=viajaso+","+yy+","+tileSelect;
			    		counterTotal=counterTotal+2;
			    	}
			    	
			    	yy=yy+8;
			    	if(yy>=height)
			    	{
			    		yy=0;
			    		xx=xx+4;
			    		desp=desp+1;
			    		if(desp==30)
			    		{
			    			viajaso=viajaso+"\n,"+(desp+200);
			    			counterTotal=counterTotal+1;
			    			desp=0;
			    		}
			    	}
			    }
			    
			    viajaso=viajaso+",200";
			    counterTotal=counterTotal+1;
			    
			    //ahora agregamos la lista de tiles al principio
			    String viajasoTiles=""+listaTiles.size(); //agregamos el numero de tiles que se van a usar
			    counterTotal=counterTotal+1;
			    //y agregamos la lista de tiles
			    for(int auxlc=0; auxlc<listaTiles.size(); auxlc++)
			    {
			    	viajasoTiles=viajasoTiles+"\n";
			    	ArrayList<Color> tileSel=listaTiles.get(auxlc);
			    	for(int auxti=0;auxti<32; auxti=auxti+4)
			    	{
			    		int ic1=calcByteValue(listaColores,tileSel.get(auxti),tileSel.get(auxti+1),tileSel.get(auxti+2),tileSel.get(auxti+3));
			    		viajasoTiles=viajasoTiles+","+ic1;
			    		counterTotal=counterTotal+1;
			    	}
			    }
			    //agregamos todo
			    viajaso=viajasoTiles+"\n\n"+viajaso;
			    
			    
			    System.out.println("OOOOMA: "+viajaso );
			    System.out.println("TOTAL: "+counterTotal);
			    
			    PrintWriter writer = new PrintWriter(file.getAbsolutePath().replaceAll("\\.png", ".tiles"), "UTF-8");
			    writer.println("extern const u8 "+file.getName().replaceAll("\\.png", "")+"["+counterTotal+"];");
			    
			    writer.println("const u8 "+file.getName().replaceAll("\\.png", "")+"["+counterTotal+"]={");
			    writer.println(viajaso);
			    writer.println("};");
			    
			    writer.close();*/
			    
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

        }
	}
	
	
}
