import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;

import de.joergjahnke.c64.swing.VirtualJoystick;

public class ImageToCompressArray {
	public static void main(String args[])
	{
		JFileChooser fc = new JFileChooser();
		
		int returnVal = fc.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) 
        {
            File file = fc.getSelectedFile();
            try {
            	BufferedImage image = ImageIO.read(file);
				final byte[] pixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
			    final int width = image.getWidth();
			    final int height = image.getHeight();
			    final boolean hasAlphaChannel = image.getAlphaRaster() != null;

			    int[][] result = new int[width][height];
			    if (hasAlphaChannel) 
			    {
			    	final int pixelLength = 4;
			        for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) 
			        {
			        	int argb = 0;
			            argb += (((int) pixels[pixel] & 0xff) << 24); // alpha
			            argb += ((int) pixels[pixel + 1] & 0xff); // blue
			            argb += (((int) pixels[pixel + 2] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 3] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) 
			            {
			            	col = 0;
			            	row++;
			            }
			        }
			     } else {
			         final int pixelLength = 3;
			         for (int pixel = 0, row = 0, col = 0; pixel < pixels.length; pixel += pixelLength) {
			            int argb = 0;
			            argb += -16777216; // 255 alpha
			            argb += ((int) pixels[pixel] & 0xff); // blue
			            argb += (((int) pixels[pixel + 1] & 0xff) << 8); // green
			            argb += (((int) pixels[pixel + 2] & 0xff) << 16); // red
			            result[col][row] = argb;
			            col++;
			            if (col == width) {
			               col = 0;
			               row++;
			            }
			         }
			      }
			    
			    
			    ArrayList<Color> listaColores=new ArrayList<Color>();
			    
			    
			    //buscar los 4 colores
			    int xx=0;
			    int yy=0;
			    while(listaColores.size()<4)
			    {
			    	Color col=new Color(result[xx][yy]);
			    	if(listaColores.indexOf(col)<0)
			    	{
			    		listaColores.add(col);
			    	}
			    	yy=yy+1;
			    	if(yy==height)
			    	{
			    		yy=0;
			    		xx=xx+1;
			    	}
			    }
			    
			    
			    //ordenar los 4 colores de más claros a más oscuros
			   
		    	listaColores.sort(new Comparator(){

					@Override
					public int compare(Object o1, Object o2) {
						Color c1=(Color)o1;
						Color c2=(Color)o2;
						return (c2.getRed()+c2.getBlue()+c2.getGreen())-(c1.getRed()+c1.getBlue()+c1.getGreen());
					}
		    		
		    	});
			   
		    	Color colBlack=listaColores.get(3);
		    	listaColores.remove(3);
		    	listaColores.add(0, colBlack);
		    	
		    	/*
		     	#define PIX_0_PAL_0 0b00000000	0
				#define PIX_0_PAL_1 0b10000000	128
				#define PIX_0_PAL_2 0b00001000	8
				#define PIX_0_PAL_3 0b10001000	136
				
				#define PIX_1_PAL_0 0b00000000	0
				#define PIX_1_PAL_1 0b01000000	64
				#define PIX_1_PAL_2 0b00000100	4
				#define PIX_1_PAL_3 0b01000100	68
				
				#define PIX_2_PAL_0 0b00000000	0
				#define PIX_2_PAL_1 0b00100000	32
				#define PIX_2_PAL_2 0b00000010	2
				#define PIX_2_PAL_3 0b00100010	34
				 
				#define PIX_3_PAL_0 0b00000000	0
				#define PIX_3_PAL_1 0b00010000	16
				#define PIX_3_PAL_2 0b00000001	1
				#define PIX_3_PAL_3 0b00010001 	17
		    	 */
		    	
		    	int counter=0;
		    	String viajaso="";
		    	boolean modoSimpleLargo=false; //si es false los bytes iran de 1 en 1 con el color, si es largo ira un byte de distancia y otro con el color
		    	//para cambiar de modo se usara el byte  83 que es un pixel de cada color (algo ke nunca va a pasar o mu raro ke pase)
		    	xx=0;
			    yy=0;
			    while(yy<height)
			    {
			    	xx=0;
			    
			    	//Color[] col=new Color[12];
			    	int col1=-1;
			    	int col2=-1;
			    	int col3=-1;
			    	
				    while(xx<width)
				    {
				    	col1=calcByteValue(listaColores,new Color(result[xx][yy]),new Color(result[xx+1][yy]),new Color(result[xx+2][yy]),new Color(result[xx+3][yy]));

				    	if(xx+4<width)
				    	{
				    		col2=calcByteValue(listaColores,new Color(result[xx+4][yy]),new Color(result[xx+5][yy]),new Color(result[xx+6][yy]),new Color(result[xx+7][yy]));
				    	}else{
				    		col2=-1;
				    	}
				    	
				    	if(xx+8<width)
				    	{
				    		col3=calcByteValue(listaColores,new Color(result[xx+8][yy]),new Color(result[xx+9][yy]),new Color(result[xx+10][yy]),new Color(result[xx+11][yy]));
				    	}else{
				    		col3=-1;
				    	}
				    	
				    	int bytesIguales=1;
				    	if(col1==col2)
				    	{
				    		bytesIguales=2;
				    		if(col1==col3)
				    		{
				    			bytesIguales=3;
				    		}
				    	}
				    	
				    	if(bytesIguales==3 && modoSimpleLargo==false)
				    	{
				    		//cambiamos de modo al largo
				    		modoSimpleLargo=true;
				    		viajaso=viajaso+",83"; //cambio de modo a largo
				    		counter=counter+1;
				    	}else if(bytesIguales<3 && modoSimpleLargo==true){
				    		modoSimpleLargo=false;
				    		viajaso=viajaso+",83"; //cambio de modo a simple
				    		counter=counter+1;
				    	}
				    	
				    	if(modoSimpleLargo==false)
				    	{
				    		if(col1==83)
				    		{
				    			col1=82;
				    		}
				    		viajaso=viajaso+","+col1;
				    		counter=counter+1;
				    		xx=xx+4;
				    	}else{
				    		//recorremos para calcular cuantos bytes hay iguales hasta el final de la linea
				    		bytesIguales=0;
				    		int auxx=xx+4;
				    		while(auxx<width && col1==col3)
				    		{
				    			col3=calcByteValue(listaColores,new Color(result[auxx][yy]),new Color(result[auxx+1][yy]),new Color(result[auxx+2][yy]),new Color(result[auxx+3][yy]));
				    			bytesIguales=bytesIguales+1;
				    			auxx=auxx+4;
				    		}
				    		viajaso=viajaso+","+col1+","+bytesIguales;
				    		counter=counter+2;
				    		xx=xx+(4*(bytesIguales));
				    	}
				    }
				    yy=yy+1;
			    }
		    	
			    System.out.println("numero:"+counter);
			    System.out.println("viajaso:"+viajaso);
			    
			    PrintWriter writer = new PrintWriter(file.getAbsolutePath().replaceAll("\\.png", ".compress"), "UTF-8");
			    writer.println("extern const u8 "+file.getName().replaceAll("\\.png", "")+"["+counter+"];");
			    
			    writer.println("const u8 "+file.getName().replaceAll("\\.png", "")+"["+counter+"]={");
			    writer.println(viajaso.substring(1));
			    writer.println("};");
			    
			    writer.close();
            } catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        }
	}
	
	
	static int calcByteValue(ArrayList<Color> listaColores,Color col1,Color col2, Color col3, Color col4)
	{
		int number=0;
    	int ind1=listaColores.indexOf(col1);
    	int ind2=listaColores.indexOf(col2);
    	int ind3=listaColores.indexOf(col3);
    	int ind4=listaColores.indexOf(col4);
    	if(ind1==1){
    		number=number+128;
    	}else if(ind1==2){
    		number=number+8;
    	}else if(ind1==3){
    		number=number+136;
    	}
    	
    	if(ind2==1){
    		number=number+64;
    	}else if(ind2==2){
    		number=number+4;
    	}else if(ind2==3){
    		number=number+68;
    	}
    	
    	if(ind3==1){
    		number=number+32;
    	}else if(ind3==2){
    		number=number+2;
    	}else if(ind3==3){
    		number=number+34;
    	}
    	
    	if(ind4==1){
    		number=number+16;
    	}else if(ind4==2){
    		number=number+1;
    	}else if(ind4==3){
    		number=number+17;
    	}
    	return number;
	}
}
